import tokensAndTrees.Terminal;
import tokensAndTrees.Tree;

public abstract class AbstractParser {
	
	public Tree startPrime( TokenSource t ) throws ParseException {
		Tree result = start( t ) ;
		expect( Terminal.EOF, t) ;
		return result ;
	}
	
	protected abstract Tree start(TokenSource t)  throws ParseException ;
	
	protected void consume(TokenSource t) {
		if( ! t.head().isEOF() ) t.advance() ;
	}
	
	protected void expect( Terminal a, TokenSource t) throws ParseException {
		if( t.head().terminal().equals(a) ) {
			consume(t) ;
		} else {
			throw new ParseException("Unexpected token " + t.head()
					+ " at position " +t.position()
					+ ". Expected a " +a+ "." ) ;
		}
	}
	
	protected boolean test( Terminal a, TokenSource t ) {
		return t.head().terminal().equals(a) ;
	}
}
