import java.util.ArrayList;
import java.util.List;

import tokensAndTrees.Eof;
import tokensAndTrees.Token;


public class ArrayTokenSource implements TokenSource {
	private final List<Token> list ;
	private int position = 0 ;
	
	ArrayTokenSource( Token[] tokens) {
		list= new ArrayList<Token>() ;
		for( Token t : tokens ) { list.add(t) ; }
		list.add( Eof.object ) ;
	}

	@Override
	public Token head() {
		return list.get( position ) ;
	}

	@Override
	public void advance() {
		position += 1 ;
	}

	@Override
	public int position() {
		return position ;
	}

}
