import tokensAndTrees.Token;


public interface TokenSource {
	/** Returns the next item in the token sequence.
	 * And does not change the state of the token source
	 * @return
	 */
	Token head() ;
	
	/** Discard the current head and make the next token in the sequence the first.
	 * Precondition ! first.isEOF(). */
	void advance() ;
	
	int position() ;
}
